﻿using System;
using System.Windows;
using System.Windows.Input;
using System.Windows.Interactivity;

namespace ReflectionIT.Phone.Behaviors {


    /// <summary>
    /// Tap gesture trigger used to invoke an action in Blend
    /// </summary>
    /// <remarks>
    /// (C)2010 Reflection IT BV - Fons Sonnemans
    /// </remarks>
    public class TapGestureTrigger : TriggerBase<UIElement> {

        /// <summary>
        /// Attach from the appropriate events.
        /// </summary>
        protected override void OnAttached() {
            base.OnAttached();
            this.AssociatedObject.ManipulationCompleted += AssociatedUIElement_ManipulationCompleted;
        }

        /// <summary>
        /// Detach from the appropriate events.
        /// </summary>
        protected override void OnDetaching() {
            base.OnDetaching();
            this.AssociatedObject.ManipulationCompleted -= AssociatedUIElement_ManipulationCompleted;

        }

        void AssociatedUIElement_ManipulationCompleted(object sender, ManipulationCompletedEventArgs e) {
            if (e.IsTapEvent) {
                this.InvokeActions(e);
            }
        }

    }


}